package de.hft.stuttgart.citydoctor2.healing;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import de.hft.stuttgart.citydoctor2.check.HealingID;
import de.hft.stuttgart.citydoctor2.check.HealingMethod;
import de.hft.stuttgart.citydoctor2.check.ModificationListener;
import de.hft.stuttgart.citydoctor2.check.error.RingNotClosedError;
import de.hft.stuttgart.citydoctor2.datastructure.LinearRing;

public class HealRingNotClosedError implements HealingMethod {
	
	private static final Logger logger = LogManager.getLogger(HealRingNotClosedError.class);

	@Override
	public boolean visit(RingNotClosedError err, ModificationListener l) {
		logger.debug("Executing Repair for RingNotClosedError");
		LinearRing ring = err.getRing();
		// add another point to close the ring
		// Geometry doesn't matter
		// only used for adjacency, but vertex already contained in ring
		ring.addVertex(ring.getVertices().get(0));
		return true;
	}

	@Override
	public HealRingNotClosedError createNew() {
		return new HealRingNotClosedError();
	}

	@Override
	public HealingID getID() {
		return HealingID.R_NOT_CLOSED;
	}

}
